//Copyright (c) 2011, Paul Lindt, Irina Lindt
//All rights reserved.

//Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    //Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    //Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or
//other materials provided with the distribution.

//THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
//WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY
//DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
//USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
//NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE 


#include"on.h"

int user_interface();
void server_interface(void *threadid);

struct on_connection my_connection;


int main(int argc, char ** argv)
{
	pthread_t server_interface_thread;
	
	on_get_user_name(my_connection.username, argc, argv);
	
	on_connect(&my_connection, CLIENT_MODE);
	
	if((pthread_create(&server_interface_thread, NULL,(void *)server_interface, 0)) != 0)
	{
		error("konnte den server_interface_thread nicht erstellen");
	}
	user_interface();
	
	on_disconnect(&my_connection, CLIENT_MODE);
	
	return 0;
}
	
void server_interface(void *threadid)
{
	int done = FALSE;
	while(!done)
	{
		print_user_interface();		
		on_recv(&my_connection);
	}
	
	
	
	
	pthread_exit(NULL);
}

int user_interface()
{
	//scheint ueberfluessig aber ohne beschwert sich getline
	int maxinput = MAX_INPUT_LENGTH;
	char *input;
	input = (char *)malloc(maxinput + 1);
	int done = FALSE;
	while(!done)
	{
		getline(&input,(size_t*)&maxinput, stdin);
		if(strcmp("/quit\n", input))
		{
			on_send(&my_connection, input);
		}
		else
		{
			done = TRUE;
		}
	}


	return 0;
}

